diff -uNrp linux-2.6.6-ia64/adeos/ia64.c linux-2.6.6-ia64-adeos/adeos/ia64.c
--- linux-2.6.6-ia64/adeos/ia64.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.6-ia64-adeos/adeos/ia64.c	2004-06-17 12:07:57.000000000 +0200
@@ -0,0 +1,602 @@
+/*
+ *   linux/adeos/ia64.c
+ *
+ *   Copyright (C) 2003,2004 Philippe Gerum.
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
+ *   USA; either version 2 of the License, or (at your option) any later
+ *   version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ *   Architecture-dependent ADEOS support for ia64.
+ */
+
+#include <linux/config.h>
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/slab.h>
+#include <linux/interrupt.h>
+#include <linux/signal.h>
+#include <linux/module.h>
+#include <asm/io.h>
+#include <asm/delay.h>
+#include <asm/iosapic.h>
+#include <asm/bitops.h>
+#include <asm/ptrace.h>
+
+#define alloc_domain_stack()	((unsigned long)__get_free_pages(GFP_KERNEL,KERNEL_STACK_SIZE_ORDER))
+#define free_domain_stack(stk)	free_pages((unsigned long)stk,KERNEL_STACK_SIZE_ORDER)
+
+extern spinlock_t __adeos_pipelock;
+
+unsigned int do_IRQ(unsigned long irq,
+		    struct pt_regs *regs);
+
+int __adeos_acknowledge_irq(unsigned irq);
+
+static struct hw_interrupt_type __adeos_std_irq_dtype[NR_IRQS];
+
+static unsigned __adeos_override_irq_startup (unsigned irq)
+
+{
+    unsigned long adflags, hwflags;
+    adeos_declare_cpuid;
+    unsigned s;
+
+    adeos_lock_cpu(hwflags);
+    adflags = adeos_test_and_stall_pipeline();
+#ifdef CONFIG_PREEMPT
+    preempt_disable();
+#endif /* CONFIG_PREEMPT */
+    __adeos_unlock_irq(adp_cpu_current[cpuid],irq);
+    s = __adeos_std_irq_dtype[irq].startup(irq);
+#ifdef CONFIG_PREEMPT
+    preempt_enable_no_resched();
+#endif /* CONFIG_PREEMPT */
+    adeos_restore_pipeline_nosync(adp_cpu_current[cpuid],adflags,cpuid);
+    adeos_unlock_cpu(hwflags);
+
+    return s;
+}
+
+static void __adeos_override_irq_shutdown (unsigned irq)
+
+{
+    unsigned long adflags, hwflags;
+    adeos_declare_cpuid;
+
+    adeos_lock_cpu(hwflags);
+    adflags = adeos_test_and_stall_pipeline();
+#ifdef CONFIG_PREEMPT
+    preempt_disable();
+#endif /* CONFIG_PREEMPT */
+    __adeos_std_irq_dtype[irq].shutdown(irq);
+    __adeos_clear_irq(adp_cpu_current[cpuid],irq);
+#ifdef CONFIG_PREEMPT
+    preempt_enable_no_resched();
+#endif /* CONFIG_PREEMPT */
+    adeos_restore_pipeline_nosync(adp_cpu_current[cpuid],adflags,cpuid);
+    adeos_unlock_cpu(hwflags);
+}
+
+static void __adeos_override_irq_enable (unsigned irq)
+
+{
+    unsigned long adflags, hwflags;
+    adeos_declare_cpuid;
+
+    adeos_lock_cpu(hwflags);
+    adflags = adeos_test_and_stall_pipeline();
+#ifdef CONFIG_PREEMPT
+    preempt_disable();
+#endif /* CONFIG_PREEMPT */
+    __adeos_unlock_irq(adp_cpu_current[cpuid],irq);
+    __adeos_std_irq_dtype[irq].enable(irq);
+#ifdef CONFIG_PREEMPT
+    preempt_enable_no_resched();
+#endif /* CONFIG_PREEMPT */
+    adeos_restore_pipeline_nosync(adp_cpu_current[cpuid],adflags,cpuid);
+    adeos_unlock_cpu(hwflags);
+}
+
+static void __adeos_override_irq_disable (unsigned irq)
+
+{
+    unsigned long adflags, hwflags;
+    adeos_declare_cpuid;
+
+    adeos_lock_cpu(hwflags);
+    adflags = adeos_test_and_stall_pipeline();
+#ifdef CONFIG_PREEMPT
+    preempt_disable();
+#endif /* CONFIG_PREEMPT */
+    __adeos_std_irq_dtype[irq].disable(irq);
+    __adeos_lock_irq(adp_cpu_current[cpuid],cpuid,irq);
+#ifdef CONFIG_PREEMPT
+    preempt_enable_no_resched();
+#endif /* CONFIG_PREEMPT */
+    adeos_restore_pipeline_nosync(adp_cpu_current[cpuid],adflags,cpuid);
+    adeos_unlock_cpu(hwflags);
+}
+
+static void __adeos_override_irq_end (unsigned irq)
+
+{
+    unsigned long adflags, hwflags;
+    adeos_declare_cpuid;
+
+    adeos_lock_cpu(hwflags);
+    adflags = adeos_test_and_stall_pipeline();
+#ifdef CONFIG_PREEMPT
+    preempt_disable();
+#endif /* CONFIG_PREEMPT */
+
+    if (!(irq_descp(irq)->status & (IRQ_DISABLED|IRQ_INPROGRESS)))
+	__adeos_unlock_irq(adp_cpu_current[cpuid],irq);
+
+    __adeos_std_irq_dtype[irq].end(irq);
+
+#ifdef CONFIG_PREEMPT
+    preempt_enable_no_resched();
+#endif /* CONFIG_PREEMPT */
+    adeos_restore_pipeline_nosync(adp_cpu_current[cpuid],adflags,cpuid);
+    adeos_unlock_cpu(hwflags);
+}
+
+static void __adeos_override_irq_affinity (unsigned irq, unsigned long mask)
+
+{
+    unsigned long adflags, hwflags;
+    adeos_declare_cpuid;
+
+    adeos_lock_cpu(hwflags);
+    adflags = adeos_test_and_stall_pipeline();
+#ifdef CONFIG_PREEMPT
+    preempt_disable();
+#endif /* CONFIG_PREEMPT */
+    __adeos_std_irq_dtype[irq].set_affinity(irq,mask);
+#ifdef CONFIG_PREEMPT
+    preempt_enable_no_resched();
+#endif /* CONFIG_PREEMPT */
+    adeos_restore_pipeline_nosync(adp_cpu_current[cpuid],adflags,cpuid);
+    adeos_unlock_cpu(hwflags);
+}
+
+static void  __adeos_enable_sync (void)
+
+{
+    __adeos_itm_next[adeos_processor_id()] = local_cpu_data->itm_next;
+    __adeos_itm_delta[adeos_processor_id()] = local_cpu_data->itm_delta;
+
+}
+
+/* __adeos_enable_pipeline() -- Take over the interrupt control from
+   the root domain (i.e. Linux). After this routine has returned, all
+   interrupts go through the pipeline. */
+
+void __adeos_enable_pipeline (void)
+
+{
+    unsigned long flags;
+    unsigned irq;
+	
+    flags = adeos_critical_enter(&__adeos_enable_sync);
+
+    /* First, grab the external interrupts. */
+
+    for (irq = IA64_MIN_VECTORED_IRQ; irq <= IA64_MAX_VECTORED_IRQ; irq++)
+	/* Fails for ADEOS_CRITICAL_IPI but that's ok. */
+	adeos_virtualize_irq(irq,
+			     (void (*)(unsigned))&do_IRQ,
+			     &__adeos_acknowledge_irq,
+			     IPIPE_HANDLE_MASK|IPIPE_PASS_MASK);
+
+    /* Interpose on the IRQ control routines so we can make them
+       atomic using hw masking and prevent the interrupt log from
+       being untimely flushed. Since we don't want to be too smart
+       about what's going on into irq.c and we want to change only
+       some of the controller members, let's be dumb and interpose the
+       rough way. */
+
+    for (irq = 0; irq < NR_IRQS; irq++)
+	__adeos_std_irq_dtype[irq] = *irq_descp(irq)->handler;
+
+    /* The original controller structs are often shared, so we first
+       save them all before changing any of them. Notice that we don't
+       redirect the ack handler since the relevant IOSAPIC management
+       code is already Adeos-aware. */
+
+    for (irq = 0; irq < NR_IRQS; irq++)
+	{
+	irq_descp(irq)->handler->startup = &__adeos_override_irq_startup;
+	irq_descp(irq)->handler->shutdown = &__adeos_override_irq_shutdown;
+	irq_descp(irq)->handler->enable = &__adeos_override_irq_enable;
+	irq_descp(irq)->handler->disable = &__adeos_override_irq_disable;
+	irq_descp(irq)->handler->end = &__adeos_override_irq_end;
+
+	if (irq_descp(irq)->handler->set_affinity != NULL)
+	    irq_descp(irq)->handler->set_affinity = &__adeos_override_irq_affinity;
+	}
+    
+    __adeos_tick_irq = __ia64_local_vector_to_irq(IA64_TIMER_VECTOR);
+    
+    __adeos_itm_next[adeos_processor_id()] = local_cpu_data->itm_next;
+    __adeos_itm_delta[adeos_processor_id()] = local_cpu_data->itm_delta;
+
+    adp_pipelined = 1;
+
+    adeos_critical_exit(flags);
+}
+
+/* __adeos_disable_pipeline() -- Disengage the pipeline. */
+
+void __adeos_disable_pipeline (void)
+
+{
+    unsigned long flags;
+    unsigned irq;
+
+    flags = adeos_critical_enter(NULL);
+
+    /* Restore interrupt controllers. */
+    for (irq = 0; irq < NR_IRQS; irq++)
+	*irq_descp(irq)->handler = __adeos_std_irq_dtype[irq];
+    
+    adp_pipelined = 0;
+
+    adeos_critical_exit(flags);
+}
+
+/* adeos_virtualize_irq_from() -- Attach a handler (and optionally a
+   hw acknowledge routine) to an interrupt for the given domain. */
+
+int adeos_virtualize_irq_from (adomain_t *adp,
+			       unsigned irq,
+			       void (*handler)(unsigned irq),
+			       int (*acknowledge)(unsigned irq),
+			       unsigned modemask)
+{
+    unsigned long flags;
+    int err;
+
+    if (irq >= IPIPE_NR_IRQS)
+	return -EINVAL;
+
+    if (adp->irqs[irq].control & IPIPE_SYSTEM_MASK)
+	return -EPERM;
+	
+    adeos_spin_lock_irqsave(&__adeos_pipelock,flags);
+
+    if (handler != NULL)
+	{
+	/* A bit of hack here: if we are re-virtualizing an IRQ just
+	   to change the acknowledge routine by passing the special
+	   ADEOS_SAME_HANDLER value, then allow to recycle the current
+	   handler for the IRQ. This allows Linux device drivers
+	   managing shared IRQ lines to call adeos_virtualize_irq() in
+	   addition to request_irq() just for the purpose of
+	   interposing their own shared acknowledge routine. */
+
+	if (handler == ADEOS_SAME_HANDLER)
+	    {
+	    handler = adp->irqs[irq].handler;
+
+	    if (handler == NULL)
+		{
+		err = -EINVAL;
+		goto unlock_and_exit;
+		}
+	    }
+	else if ((modemask & IPIPE_EXCLUSIVE_MASK) != 0 &&
+		 adp->irqs[irq].handler != NULL)
+	    {
+	    err = -EBUSY;
+	    goto unlock_and_exit;
+	    }
+	
+	if ((modemask & (IPIPE_SHARED_MASK|IPIPE_PASS_MASK)) == IPIPE_SHARED_MASK)
+	    {
+	    err = -EINVAL;
+	    goto unlock_and_exit;
+	    }
+
+	if ((modemask & IPIPE_STICKY_MASK) != 0)
+	    modemask |= IPIPE_HANDLE_MASK;
+	}
+    else
+	modemask &= ~(IPIPE_HANDLE_MASK|IPIPE_STICKY_MASK|IPIPE_SHARED_MASK);
+
+    if (acknowledge == NULL)
+	{
+	if ((modemask & IPIPE_SHARED_MASK) == 0)
+	    /* Acknowledge handler unspecified -- this is ok in
+	       non-shared management mode, but we will force the use
+	       of the Linux-defined handler instead. */
+	    acknowledge = adp_root->irqs[irq].acknowledge;
+	else
+	    {
+	    /* A valid acknowledge handler to be called in shared mode
+	       is required when declaring a shared IRQ. */
+	    err = -EINVAL;
+	    goto unlock_and_exit;
+	    }
+	}
+
+    adp->irqs[irq].handler = handler;
+    adp->irqs[irq].acknowledge = acknowledge;
+    adp->irqs[irq].control = modemask;
+
+    if (irq < NR_IRQS &&
+	handler != NULL &&
+	!adeos_virtual_irq_p(irq) &&
+	(modemask & IPIPE_ENABLE_MASK) != 0)
+	{
+	if (adp != adp_current)
+	    {
+	    /* IRQ enable/disable state is domain-sensitive, so we may
+	       not change it for another domain. What is allowed
+	       however is forcing some domain to handle an interrupt
+	       source, by passing the proper 'adp' descriptor which
+	       thus may be different from adp_current. */
+	    err = -EPERM;
+	    goto unlock_and_exit;
+	    }
+
+	irq_descp(irq)->handler->enable(irq);
+	}
+
+    err = 0;
+
+unlock_and_exit:
+
+    adeos_spin_unlock_irqrestore(&__adeos_pipelock,flags);
+
+    return err;
+}
+
+/* adeos_control_irq() -- Change an interrupt mode. This affects the
+   way a given interrupt is handled by ADEOS for the current
+   domain. setmask is a bitmask telling whether:
+   - the interrupt should be passed to the domain (IPIPE_HANDLE_MASK),
+     and/or
+   - the interrupt should be passed down to the lower priority domain(s)
+     in the pipeline (IPIPE_PASS_MASK).
+   This leads to four possibilities:
+   - PASS only => Ignore the interrupt
+   - HANDLE only => Terminate the interrupt (process but don't pass down)
+   - PASS + HANDLE => Accept the interrupt (process and pass down)
+   - <none> => Discard the interrupt
+   - DYNAMIC is currently an alias of HANDLE since it marks an interrupt
+   which is processed by the current domain but not implicitely passed
+   down to the pipeline, letting the domain's handler choose on a case-
+   by-case basis whether the interrupt propagation should be forced
+   using adeos_propagate_irq().
+   clrmask clears the corresponding bits from the control field before
+   setmask is applied.
+*/
+
+int adeos_control_irq (unsigned irq,
+		       unsigned clrmask,
+		       unsigned setmask)
+{
+    unsigned long flags;
+    irq_desc_t *desc;
+
+    if (irq >= IPIPE_NR_IRQS)
+	return -EINVAL;
+
+    if (adp_current->irqs[irq].control & IPIPE_SYSTEM_MASK)
+	return -EPERM;
+	
+    if (((setmask|clrmask) & IPIPE_SHARED_MASK) != 0)
+	return -EINVAL;
+	
+    desc = __ia64_irq_desc(irq);
+
+    if (adp_current->irqs[irq].handler == NULL)
+	setmask &= ~(IPIPE_HANDLE_MASK|IPIPE_STICKY_MASK);
+
+    if ((setmask & IPIPE_STICKY_MASK) != 0)
+	setmask |= IPIPE_HANDLE_MASK;
+
+    if ((clrmask & (IPIPE_HANDLE_MASK|IPIPE_STICKY_MASK)) != 0)	/* If one goes, both go. */
+	clrmask |= (IPIPE_HANDLE_MASK|IPIPE_STICKY_MASK);
+
+    adeos_spin_lock_irqsave(&__adeos_pipelock,flags);
+
+    adp_current->irqs[irq].control &= ~clrmask;
+    adp_current->irqs[irq].control |= setmask;
+
+    if ((setmask & IPIPE_ENABLE_MASK) != 0)
+	desc->handler->enable(irq);
+    else if ((clrmask & IPIPE_ENABLE_MASK) != 0)
+	desc->handler->disable(irq);
+
+    adeos_spin_unlock_irqrestore(&__adeos_pipelock,flags);
+
+    return 0;
+}
+
+void __adeos_init_domain (adomain_t *adp, adattr_t *attr)
+
+{
+    unsigned long rbs, bspstore, child_stack, child_rbs, rbs_size;
+    int _cpuid, nr_cpus = num_online_cpus();
+    void (*entry)(int) = attr->entry; /* keep this in a saved reg */
+    struct switch_stack *swstack;
+    adeos_declare_cpuid;
+
+    adeos_load_cpuid();
+
+    /* Make sure the new domain stack is congruent to that of the
+       current Linux task, modulo 512, so that NaT bits are properly
+       spilled/filled to/from ar.unat. Given the strict page alignment
+       constraint we have for domain stacks, the user-provided hint
+       for stack size (attr->estacksz) is not even considered, i.e. on
+       ia64, domain stacks have a fixed size of KERNEL_STACK_SIZE
+       bytes. */
+
+    for (_cpuid = 0; _cpuid < nr_cpus; _cpuid++)
+	{
+	adp->estackbase[_cpuid] = alloc_domain_stack();
+
+	if (adp->estackbase[_cpuid] == 0)
+	    panic("Adeos: no memory for domain stack on CPU #%d",_cpuid);
+
+	/* Build a switch stack frame at the bottom of the new domain
+	   stack as a clone of the parent context. */
+
+	__adeos_fork_domain(adp->estackbase[_cpuid] + KERNEL_STACK_SIZE);
+
+	if (adp_current != adp_root)
+	    {
+	    /* Child return path (upon initial switch in). */
+	    clear_bit(IPIPE_SLEEP_FLAG,&adp->cpudata[_cpuid].status);
+	    adeos_hw_sti();
+
+	    /* Here we don't care if a CPU migration has occured since
+	       we do not use the cpuid for accessing per-CPU data, but
+	       we don't want more than one CPU to be passed iflag ==
+	       1. */
+
+	    entry(_cpuid == cpuid);
+	    panic("Adeos: spurious return from domain %s\n",adp_current->name);
+	    }
+
+	/* Parent return path. */
+
+	child_stack = adp->estackbase[_cpuid] + KERNEL_STACK_SIZE - IA64_SWITCH_STACK_SIZE;
+	adp->esp[_cpuid] = child_stack;
+	swstack = (struct switch_stack *)child_stack;
+	bspstore = swstack->ar_bspstore;
+
+	/* Copy the parent's register backing store to the new
+	   domain's stack.  Since __adeos_init_domain() must be called
+	   on behalf of the root domain (i.e. Linux), referring to
+	   "current" is always valid here. The register backing store
+	   grows upward from the stack base. */
+
+        rbs = (unsigned long)current + IA64_RBS_OFFSET;
+        child_rbs = adp->estackbase[_cpuid] + IA64_RBS_OFFSET;
+        rbs_size = bspstore - rbs;
+
+        memcpy((void *)child_rbs,(void *)rbs,rbs_size);
+	swstack->ar_bspstore = child_rbs + rbs_size;
+	adp->esp[_cpuid] -= 16;	/* Provide for the (bloody) scratch area... */
+	}
+}
+
+void __adeos_cleanup_domain (adomain_t *adp)
+
+{
+    int _cpuid, nr_cpus = num_online_cpus();
+
+    adeos_unstall_pipeline_from(adp);
+
+    for (_cpuid = 0; _cpuid < nr_cpus; _cpuid++)
+	{
+#ifdef CONFIG_SMP
+	while (adp->cpudata[_cpuid].irq_pending_hi != 0)
+	    cpu_relax();
+
+	while (test_bit(IPIPE_XPEND_FLAG,&adp->cpudata[_cpuid].status))
+	    cpu_relax();
+#endif /* CONFIG_SMP */
+
+	if (adp->estackbase[_cpuid] != 0)
+	    free_domain_stack(adp->estackbase[_cpuid]);
+	}
+}
+
+int adeos_get_sysinfo (adsysinfo_t *info)
+
+{
+    info->ncpus = num_online_cpus();
+    info->cpufreq = adeos_cpu_freq();
+    info->archdep.tmirq = __adeos_tick_irq;
+
+    return 0;
+}
+
+void __adeos_set_itm (void)
+
+{
+    unsigned long itm_next = ia64_get_itc();
+    adeos_declare_cpuid;
+
+    adeos_load_cpuid();
+
+    itm_next += __adeos_itm_delta[cpuid];
+    ia64_set_itm(itm_next);
+
+    __adeos_itm_next[cpuid] = itm_next;    
+}
+
+int adeos_tune_timer (unsigned long ns, int flags)
+
+{
+    int _cpuid, nr_cpus = num_online_cpus();
+    unsigned long x;
+    unsigned _hz;
+    
+    if (flags & ADEOS_RESET_TIMER)
+	_hz = HZ;
+    else
+	_hz = 1000000000 / ns;
+
+    x = adeos_critical_enter(__adeos_set_itm); /* Sync with all CPUs */
+
+    for (_cpuid = 0; _cpuid < nr_cpus; _cpuid++)
+	__adeos_itm_delta[_cpuid] = (cpu_data(_cpuid)->itc_freq + _hz/2) / _hz;
+
+    __adeos_set_itm();
+
+    adeos_critical_exit(x);
+    
+    return 0;
+}
+
+/* adeos_trigger_ipi() -- Send the ADEOS service IPI to other
+   processors. */
+
+int adeos_trigger_ipi (int _cpuid)
+
+{
+#ifdef CONFIG_SMP
+    int nr_cpus = num_online_cpus();
+    unsigned long flags;
+    adeos_declare_cpuid;
+
+    adeos_lock_cpu(flags);
+
+    if (unlikely(_cpuid == cpuid)) /* Self-posting the service interrupt? */
+	adeos_trigger_irq(ADEOS_SERVICE_IPI);
+    else
+	{
+	if (_cpuid == ADEOS_OTHER_CPUS)
+	    {
+	    if (nr_cpus > 1)
+		/* Send the service IPI to all processors but the current one. */
+		__adeos_send_IPI_allbutself(ADEOS_SERVICE_VECTOR);
+	    }
+	else if (_cpuid >= 0 && _cpuid < nr_cpus)
+	    __adeos_send_IPI_other(_cpuid,ADEOS_SERVICE_VECTOR);
+	}
+
+    adeos_unlock_cpu(flags);
+
+    return _cpuid != ADEOS_OTHER_CPUS ? 1 : nr_cpus - 1;
+#else  /* !CONFIG_SMP */
+    return 0;
+#endif /* CONFIG_SMP */
+}
diff -uNrp linux-2.6.6-ia64/arch/ia64/kernel/Makefile linux-2.6.6-ia64-adeos/arch/ia64/kernel/Makefile
--- linux-2.6.6-ia64/arch/ia64/kernel/Makefile	2004-06-17 11:19:10.000000000 +0200
+++ linux-2.6.6-ia64-adeos/arch/ia64/kernel/Makefile	2004-06-17 11:45:44.000000000 +0200
@@ -8,6 +8,7 @@ obj-y := acpi.o entry.o efi.o efi_stub.o
 	 irq_lsapic.o ivt.o machvec.o pal.o patch.o process.o perfmon.o ptrace.o sal.o		\
 	 salinfo.o semaphore.o setup.o signal.o sys_ia64.o time.o traps.o unaligned.o unwind.o mca.o mca_asm.o
 
+obj-$(CONFIG_ADEOS_CORE)	+= adeos.o
 obj-$(CONFIG_IA64_BRL_EMU)	+= brl_emu.o
 obj-$(CONFIG_IA64_GENERIC)	+= acpi-ext.o
 obj-$(CONFIG_IA64_HP_ZX1)	+= acpi-ext.o
